/* Button styles ================ */
.button {
  --button-min-width: 100px;
  --button-height: 50px;
  --button-padding-horizontal: 25px;
  --button-border: 2px solid var(--color-primary-dark);
  --button-border-radius: 30px;

  --button-font-size: 18px;
  --button-font-weight: var(--text-font-weight-bold);

  --button-background-color: var(--color-white);
  --button-background-color-hover: var(--color-primary-dark);
  --button-background-color-active: color-mod(var(--color-primary-dark) blackness(20%));

  --button-text-color: var(--color-black-light);
  --button-text-color-hover: var(--color-white);

  display: inline-flex;
  justify-content: center;
  align-items: center;

  min-width: var(--button-min-width);
  max-width: 100%;
  height: var(--button-height);
  padding-left: var(--button-padding-horizontal);
  padding-right: var(--button-padding-horizontal);

  position: relative;

  border: var(--button-border);
  border-radius: var(--button-border-radius);

  background-color: var(--button-background-color);

  font-size: var(--button-font-size);
  font-weight: var(--button-font-weight);
  text-align: center;
  text-decoration: none;
  text-transform: uppercase;
  color: var(--button-text-color);

  transition: background-color .3s ease;
  cursor: pointer;
  z-index: var(--z-index-button);
  overflow: hidden;

  touch-action: manipulation;
  user-select: none;
  -webkit-appearance: inherit;

  &:hover {
    background-color: var(--button-background-color-hover);
    text-decoration: none;
    color: var(--button-text-color-hover);
  }

  &:active {
    background-color: var(--button-background-color-active);
  }

  &.button--no-border {
    border-color: transparent;
  }

  &.button--full-width {
    width: 100%;
  }

  @media (--laptop-small-max) {
    --button-font-size: 14px;
    --button-height: 40px;
    text-transform: none;
  }
}

.button--small {
  --button-font-size: 14px;
  --button-height: 38px;

  height: var(--button-height);
  font-size: var(--button-font-size);

  @media (--tablet-small-max) {
    --button-font-size: 12px;
  }
}

.button--rose {
  --button-background-color: var(--color-primary-dark);
  --button-background-color-hover: var(--color-white);
  --button-background-color-active: color-mod(var(--color-primary-dark) blackness(10%));

  --button-text-color: var(--color-white);
  --button-text-color-hover: var(--color-black-light);
  --button-text-color-active: var(--color-white);

  background-color: var(--button-background-color);
  color: var(--button-text-color);

  &:hover {
    background-color: var(--button-background-color-hover);
    color: var(--button-text-color-hover);
  }

  &:active {
    background-color: var(--button-background-color-active);
    color: var(--button-text-color-active);
  }
}

.button__text {
  color: currentColor;
  white-space: nowrap;
  text-overflow: ellipsis;
  overflow: hidden;
}

/* disabled styles */
.button--disabled,
.button[disabled],
fieldset[disabled] .button {
  box-shadow: none;
  cursor: not-allowed;
  opacity: .32;
  pointer-events: none;
}

button[type = "button"] {
  cursor: pointer;
}
/* ================ end button styles */
